﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Battleship.DrawningObjects;
using Battleship.Entities;
using System.Diagnostics.CodeAnalysis;

namespace Battleship.Generics
{
    internal class DrawningShipEqutables: IEqualityComparer<DrawningShip?>
    {
        public bool Equals(DrawningShip? x, DrawningShip? y)
        {
            if (x == null || x.EntityShip == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityShip == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return false;
            }
            if (x.EntityShip.Speed != y.EntityShip.Speed)
            {
                return false;
            }
            if (x.EntityShip.Weight != y.EntityShip.Weight)
            {
                return false;
            }
            if (x.EntityShip.BodyColor != y.EntityShip.BodyColor)
            {
                return false;
            }
            if (x is DrawningBattleship && y is DrawningBattleship)
            {
                EntityBattleship EntityX = (EntityBattleship)x.EntityShip;
                EntityBattleship EntityY = (EntityBattleship)y.EntityShip;

                if (EntityX.Tower != EntityY.Tower)
                    return false;
                if(EntityX.Section != EntityY.Section)
                    return false;
                if(EntityX.AdditionalColor != EntityY.AdditionalColor)
                    return false;
            }
            return true;
        }

        public int GetHashCode([DisallowNull] DrawningShip obj)
        {
            return obj.GetHashCode();
        }
    }
}
