﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Battleship.DrawningObjects;


namespace Battleship.Generics
{
    internal class ShipCompareByType: IComparer<DrawningShip?>
    {
        public int Compare(DrawningShip? x, DrawningShip? y)
        {
            if (x == null || x.EntityShip == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityShip == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare =
            x.EntityShip.Speed.CompareTo(y.EntityShip.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityShip.Weight.CompareTo(y.EntityShip.Weight);
        }
    }
}
